;;DESKTOP CHOKES WITH BOTH LINES AND HARMONIC FILTERS RUNNING--LAPTOP CHOKES WITH HARMONIC FILTERS
;;INSTEAD OF MAKING CHANGES AT THE K-RATE, TRY A SLOWER RATE TO SEE IF IT HELPS
;;IF SLOWER RATE DOESN'T WORK, THEN CHANGE LINES AND HARMONICS TO THE RANDOM MODEL WITH ARRMORPH LIKE RANDOM

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CABBAGE CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2)
#define BASIC colour(56, 150, 180, 255) trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define RSLIDER colour(56, 150, 180, 255) trackerColour("MediumTurquoise") fontColour("Gainsboro") valueTextBox(1) textBoxColour("black") 
#define FONT fontColour("Gainsboro")

;MAIN GUI:
form caption("Spectral Diffuser") channel("f1") size(600,615) pluginId("SF01") colour(76,130,180,155) guiMode("queue") fontColour("Gainsboro")

label channel("l52") bounds(275,5,50,20) text("Input") $FONT
filebutton bounds(10,5,75,20) channel("openFile") text("Load SF") $BUTTONS presetIgnore(1)
button bounds(90,5,45,20) channel("sfplay") text("Play") $BUTTONS presetIgnore(1)
button bounds(140,5,45,20) channel("sfloop") text("Loop") $BUTTONS presetIgnore(1)
rslider bounds(180,0,60,40) channel("sfamp") range(0,5,.75,0.75,0.001) $RSLIDER presetIgnore(1)
button bounds(405,5,60,20) channel("liveon") text("Mic/Line") $BUTTONS presetIgnore(1)
combobox bounds(470,5,60,20) channel("livech") text("Stereo","Mono") value(1) presetIgnore(1)
rslider bounds(525,0,60,40) channel("liveamp") range(0,5,.75,0.75,0.001) $RSLIDER presetIgnore(1)

image channel("ifilter") bounds(5,50,590,560) plant("Filter") $PLANT
{
;button bounds(5,5,95,40) channel("filt") latched(1) text("spectral filter") $BUTTONS
label bounds(5,5,25,15) channel("lf1") text("in") $FONT
combobox bounds(35,5,70,20) channel("filtsource") items("mic/line","soundfile") value(2)

label bounds(105,5,260,15) channel("lf2") text("functions sum to create the filter") $FONT
label bounds(105,20,260,15) channel("lf2") text("(bottom image)") $FONT

label channel("l51") bounds(360,5,80,20) text("Presets") $FONT
combobox bounds(365,30,195,20) populate("*.snaps") channelType("string") channel("cb1") value(1) ;$FONT
filebutton bounds(445,5,50,20) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(500,5,60,20) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1)

rslider bounds(5,30,65,45) channel("calcrate") range(25,500,250,1,25) $RSLIDER
label bounds(60,55,500,15) channel("lcalcrate") text("master line/harmonic calculation rate (use lower rate for slower CPUs)") $FONT

;label bounds(5,75,50,18) channel("l6") text("Line") $FONT
button bounds(5,80,95,60) channel("rline") latched(1) text("Random Lines") $BUTTONS
label bounds(95,75,120,15) channel("l7") text("start min/max") $FONT
label bounds(215,75,120,15) channel("l8") text("end min/max") $FONT
label bounds(330,75,120,15) channel("l9") text("F min/max") $FONT
label bounds(445,75,120,15) channel("llsp") text("speed min/max") $FONT
rslider bounds(105,90,65,45) channel("offsetstart1") range(.001,1,.25,1,.001) $RSLIDER
rslider bounds(155,90,65,45) channel("offsetstart2") range(.001,1,.57,1,.001) $RSLIDER
rslider bounds(220,90,65,45) channel("offsetend1") range(.001,1,.25,1,.001) $RSLIDER
rslider bounds(270,90,65,45) channel("offsetend2") range(.001,1,.75,1,.001) $RSLIDER
rslider bounds(335,90,65,45) channel("lineF1") range(1,250,1,.1) $RSLIDER
rslider bounds(385,90,65,45) channel("lineF2") range(1,250,2,1,.1) $RSLIDER
rslider bounds(450,90,65,45) channel("linerate1") range(.1,50,.75,1,.01) $RSLIDER
rslider bounds(500,90,65,45) channel("linerate2") range(.1,50,1.25,1,.01) $RSLIDER

button bounds(5,150,95,60) channel("rgen") latched(1) text("Random") $BUTTONS
label bounds(100,145,120,15) channel("l22") text("amp min/max") $FONT
rslider bounds(105,160,65,45) channel("nzscale1") range(0,1,0,1,0.001) $RSLIDER
rslider bounds(155,160,65,45) channel("nzscale2") range(0,1,.5,1,0.001) $RSLIDER
label bounds(220,145,120,15) channel("l24") text("speed min/max") $FONT
rslider bounds(220,160,65,45) channel("rrate1") range(.1,50,1,1,0.1) $RSLIDER 
rslider bounds(270,160,65,45) channel("rrate2") range(.1,50,2,1,0.1) $RSLIDER 

button bounds(5,220,95,60) channel("harm") latched(1) text("Harmonic") $BUTTONS
label bounds(100,215,120,15) channel("l11") text("amp min/max") $FONT
rslider bounds(105,230,65,45) channel("sinamp1") range(0,1,0,1,.001) $RSLIDER
rslider bounds(155,230,65,45) channel("sinamp2") range(0,1,.5,1,.001) $RSLIDER
label bounds(220,215,120,15) channel("l10") text("F min/max") $FONT
rslider bounds(220,230,75,45) channel("sinF1") range(0,20000,40,.5,.1) $RSLIDER
rslider bounds(270,230,75,45) channel("sinF2") range(0,20000,400,.5,.1) $RSLIDER
label bounds(335,215,120,15) channel("l34") text("spread min/max") $FONT
rslider bounds(335,230,65,45) channel("spread1") range(1,500,30,1,.1) $RSLIDER
rslider bounds(385,230,65,45) channel("spread2") range(1,500,80,1,.1) $RSLIDER
label bounds(450,215,120,15) channel("l33") text("ctr min/max") $FONT
rslider bounds(450,230,65,45) channel("ctrh1") range(-200,200,1,1,.1) $RSLIDER
rslider bounds(500,230,65,45) channel("ctrh2") range(-200,200,2,1,.1) $RSLIDER
label bounds(105,285,120,15) channel("l15") text("Q min/max") $FONT
rslider bounds(105,300,65,45) channel("Q1") range(.5,100,1,.5,.01) $RSLIDER
rslider bounds(155,300,65,45) channel("Q2") range(.5,100,10,.5,.01) $RSLIDER
label bounds(220,285,120,15) channel("lhspeed") text("speed min/max") $FONT
rslider bounds(220,300,65,45) channel("hspeed1") range(.1,50,1,1,0.1) $RSLIDER 
rslider bounds(270,300,65,45) channel("hspeed2") range(.1,50,2,1,0.1) $RSLIDER 

gentable bounds(10,355,570,135) channel("arraydisplayL") tableNumber(99) ampRange(0,1,99,.001) outlineThickness(2) $FTABLES ;identChannel("table99")

label bounds(0,500,75,18) channel("l12") text("Mix") $FONT
rslider bounds(50,500,65,55) channel("fmix") range(0,1,1,1,.01) $RSLIDER
label bounds(100,500,75,18) channel("lfilto") text("out") $FONT
rslider bounds(150,500,65,55) channel("fout") range(0,2,1,1,.01) $RSLIDER

button bounds(250,500,75,45) channel("record") text("Record","Stop") colour("red") fontColour("white")
combobox bounds(335,500,150,20) channel("recch") value(2) text("mono -> stereo","mono -> 4","stereo -> 4","stereo -> 8") value(1)
combobox bounds(335,525,150,20) channel("bit") value(1) text("16-bit","24-bit","32-bit") value(1)
button bounds(495,500,75,45), channel("play") text("Play") colour("green") fontColour("white") value(0)
}

</Cabbage>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CSOUND CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 --displays ;sends MIDI note number and velocity to instr 1 as p4 and p5 respectively
</CsOptions>
<CsInstruments>

; Initialize the global variables. 
gisr=sr
ksmps = 100 ;tried sr*.01 but then you hear the 441 Hz control period
nchnls = 8
0dbfs = 1

gkstatus,gkchan,gkdata1,gkdata2 init 0 ;initialize global MIDI settings
gichnls init 0 ;globals for soundfile table loading
giReady init 0
gSfilepath init ""
gkTabLen init 2
giTable init 601
gkRecordingActiveFlag,gkFileRecorded init 0
gafiltL,gafiltR init 0 ;gafinalL,gafinalR,gafreezeL,gafreezeR,gamorphL,gamorphR,gadevL,gadevR,gatraceinL,gatraceinR,gatraceL,gatraceR
gamicL,gamicR,gasfL,gasfR init 0
gisize init 2048
;following needed for random generators
gkNz1[] init gisize
gkRandcurrent1[] init gisize
gkRandtarget1[] init gisize
gkNz2[] init gisize
gkRandcurrent2[] init gisize
gkRandtarget2[] init gisize
gkNz3[] init gisize
gkRandcurrent3[] init gisize
gkRandtarget3[] init gisize
gkNz4[] init gisize
gkRandcurrent4[] init gisize
gkRandtarget4[] init gisize
;following needed for random line generators
gkLine1[] init gisize
gkLine2[] init gisize
gkLine3[] init gisize
gkLine4[] init gisize
;following needed for random harmonics generators
gkCosA1[] init gisize
gkFWinA[] init gisize
gkCosA[] init gisize
gkCosB1[] init gisize
gkFWinB[] init gisize
gkCosB[] init gisize
gkCosC1[] init gisize
gkFWinC[] init gisize
gkCosC[] init gisize
gkCosD1[] init gisize
gkFWinD[] init gisize
gkCosD[] init gisize

gkSumL1[] init gisize
gkSumL1i[] init gisize
gkSumL2[] init gisize
gkSumL2i[] init gisize
gkSumR1[] init gisize
gkSumR1i[] init gisize
gkSumR2[] init gisize
gkSumR2i[] init gisize

;set up all the arrays needed to be able to provide any array input into instruments 15-16, 25-31 and 40-41
gkBinsL[] init gisize+2 ;used to write incoming audio into arrays
gkBinsR[] init gisize+2
gkMicL[] init gisize+2
gkMicR[] init gisize+2
gkSfL[] init gisize+2
gkSfR[] init gisize+2

gktrigger init 250

opcode arrmorph, k[], kk[]k[]i ;morph two arrays
    kfact,k1[],k2[],isize xin
    kout[] init isize
        kout = k1*(1-kfact) + k2*kfact      
    xout kout
endop  

instr 1   ;live audio input and record/play control
kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
kcalcrate chnget "calcrate"
if changed(kcalcrate)==1then
gktrigger=kcalcrate
endif
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

kliveon chnget "liveon"
kliveon port kliveon,.025
klivech chnget "livech"
kliveamp chnget "liveamp"

ainL,ainR inch 1,2 ;brings in audio from channels 1 and 2
ainL=ainL*kliveon*kliveamp
ainR=ainR*kliveon*kliveamp
if klivech=1 then
gamicL=ainL
gamicR=ainR
else
gamicL=ainL+ainR
gamicR=ainL+ainR
endif

fftmicL pvsanal ainL,gisize,gisize*.25,gisize,1
fftmicR pvsanal ainR,gisize,gisize*.25,gisize,1
kmicframeL pvs2array gkMicL,fftmicL ;constantly writing fftL into an array gkBins so I can grab it
kmicframeR pvs2array gkMicR,fftmicR

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif
  
krgen chnget "rgen"
if changed(krgen)==1 then
 if krgen=1 then ;could add code here to set up ongoing changes with rate random within %range
  turnoff2 11,0,.05 ;turn off random array morphing instrument
  event "i",10,0,999999 ;ksmps/sr ;turns on i5 for one k-rate period
  event "i",11,.001,999999 ;ksmps/sr ;turns on i5 for one k-rate period
  event "i",12,.002,999999 ;ksmps/sr ;turns on i5 for one k-rate period
  event "i",13,.003,999999 ;ksmps/sr ;turns on i5 for one k-rate period
  else
  turnoff2 10,0,.05
  turnoff2 11,0,.05
  turnoff2 12,0,.05
  turnoff2 13,0,.05
 endif
endif

krline chnget "rline" ;random line generator engine in i20
if changed(krline)==1 then
 if krline=1 then
 event "i",20,0,999999
 event "i",21,.001,999999
 event "i",22,.002,999999
 event "i",23,.003,999999
 else
 turnoff2 20,0,.05
 turnoff2 21,0,.05
 turnoff2 22,0,.05
 turnoff2 23,0,.05
 endif
endif

kharm chnget "harm" ;random harmonic generator engine in i30
if changed(kharm)==1 then
 if kharm=1 then
 event "i",30,0,999999
 event "i",31,0,999999
 event "i",32,0,999999
 event "i",33,0,999999
 else
 turnoff2 30,0,.05
 turnoff2 31,.001,.05
 turnoff2 32,.002,.05
 turnoff2 33,.003,.05
 endif
endif

outs gamicL,gamicR
endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
    if  gichnls==1 then
    a1  loscil 1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv
    gasfR=a1*kingain*kEnv
    elseif  gichnls==2 then
    a1,a2   loscil  1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv
    gasfR=a2*kingain*kEnv
    endif

;use chnset to turn off "sfplay" automatically IF "sfloop" is not on
;look at Poovey code as model

fftsfL pvsanal gasfL,gisize,gisize*.25,gisize,1
fftsfR pvsanal gasfR,gisize,gisize*.25,gisize,1
ksfframeL pvs2array gkSfL,fftsfL ;constantly writing fftL into an array gkBins so I can grab it
ksfframeR pvs2array gkSfR,fftsfR
endin

instr 3
giTable ftgen 1,0,0,1,gSfilepath,0,0,0
gichnls filenchnls gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen init ftlen(giTable)/gichnls
Smessage sprintfk "file(%s)",gSfilepath
endin

instr 10 ;instrument that generates random tables on command
krrate1 chnget "rrate1"
krrate2 chnget "rrate2"
knzscale1 chnget "nzscale1"
knzscale2 chnget "nzscale2"
if krrate1>krrate2 then ;invert values despite user input
 krratetemp=krrate2
 krrate2=krrate1
 krrate1=krratetemp
endif
if knzscale1>knzscale2 then ;invert values despite user input
 knzscaletemp=knzscale2
 knzscale2=knzscale1
 knzscale1=knzscaletemp
endif
kraterand randomh 0,krrate2-krrate1,krrate1,3
krrate=krrate1+kraterand
knzbi=knzscale2-knzscale1
kamp randh knzbi,krrate
ktrig metro krrate ;generate a trigger to do random calculation
if ktrig=1 then
gkRandcurrent1=gkNz1 ;load array used for maska FFT into current array
copya2ftab gkRandcurrent1,201 ;write current array to f201
koffsetindex=0 ;generate new random table and load into target array
 until koffsetindex==gisize do
 gkRandtarget1[koffsetindex] = rand:k(kamp,2) ;seed of greater than 1 gets seed from clock
 koffsetindex += 1
 od
copya2ftab gkRandtarget1,202 ;write target array to f202 
event "i",11,0,1/krrate
endif
endin

instr 11 ;instrument to morph two arrays
kmorph line 0,p3,1 ;ramp from 0-1
gkNz1 arrmorph kmorph,gkRandcurrent1,gkRandtarget1,gisize ;actual morphing from current to target
endin

instr 12 ;instrument that generates random tables on command
krrate1 chnget "rrate1"
krrate2 chnget "rrate2"
knzscale1 chnget "nzscale1"
knzscale2 chnget "nzscale2"
if krrate1>krrate2 then ;invert values despite user input
 krratetemp=krrate2
 krrate2=krrate1
 krrate1=krratetemp
endif
if knzscale1>knzscale2 then ;invert values despite user input
 knzscaletemp=knzscale2
 knzscale2=knzscale1
 knzscale1=knzscaletemp
endif
kraterand randomh 0,krrate2-krrate1,krrate1,3
krrate=krrate1+kraterand
knzbi=knzscale2-knzscale1
kamp randh knzbi,krrate
ktrig metro krrate ;generate a trigger to do random calculation
if ktrig=1 then
gkRandcurrent2=gkNz2 ;load array used for maska FFT into current array
copya2ftab gkRandcurrent2,204 ;write current array to f204
koffsetindex=0 ;generate new random table and load into target array
 until koffsetindex==gisize do
 gkRandtarget2[koffsetindex] = rand:k(kamp,2) ;seed of greater than 1 gets seed from clock
 koffsetindex += 1
 od
copya2ftab gkRandtarget2,205 ;write target array to f205 
event "i",13,0,1/krrate
endif
endin

instr 13 ;instrument to morph two arrays
kmorph line 0,p3,1 ;ramp from 0-1
gkNz2 arrmorph kmorph,gkRandcurrent2,gkRandtarget2,gisize ;actual morphing from current to target
copya2ftab gkNz2,203 ;write contents of active amp mask noise array into f200
endin

instr 14 ;instrument that generates random tables on command
krrate1 chnget "rrate1"
krrate2 chnget "rrate2"
knzscale1 chnget "nzscale1"
knzscale2 chnget "nzscale2"
if krrate1>krrate2 then ;invert values despite user input
 krratetemp=krrate2
 krrate2=krrate1
 krrate1=krratetemp
endif
if knzscale1>knzscale2 then ;invert values despite user input
 knzscaletemp=knzscale2
 knzscale2=knzscale1
 knzscale1=knzscaletemp
endif
kraterand randomh 0,krrate2-krrate1,krrate1,3
krrate=krrate1+kraterand
knzbi=knzscale2-knzscale1
kamp randh knzbi,krrate
ktrig metro krrate ;generate a trigger to do random calculation
if ktrig=1 then
gkRandcurrent1=gkNz1 ;load array used for maska FFT into current array
copya2ftab gkRandcurrent1,201 ;write current array to f201
koffsetindex=0 ;generate new random table and load into target array
 until koffsetindex==gisize do
 gkRandtarget1[koffsetindex] = rand:k(kamp,2) ;seed of greater than 1 gets seed from clock
 koffsetindex += 1
 od
copya2ftab gkRandtarget1,202 ;write target array to f202 
event "i",15,0,1/krrate
endif
endin

instr 15 ;instrument to morph two arrays
kmorph line 0,p3,1 ;ramp from 0-1
gkNz1 arrmorph kmorph,gkRandcurrent1,gkRandtarget1,gisize ;actual morphing from current to target
copya2ftab gkNz1,200 ;write contents of active amp mask noise array into f200
endin

instr 16 ;instrument that generates random tables on command
krrate1 chnget "rrate1"
krrate2 chnget "rrate2"
knzscale1 chnget "nzscale1"
knzscale2 chnget "nzscale2"
if krrate1>krrate2 then ;invert values despite user input
 krratetemp=krrate2
 krrate2=krrate1
 krrate1=krratetemp
endif
if knzscale1>knzscale2 then ;invert values despite user input
 knzscaletemp=knzscale2
 knzscale2=knzscale1
 knzscale1=knzscaletemp
endif
kraterand randomh 0,krrate2-krrate1,krrate1,3
krrate=krrate1+kraterand
knzbi=knzscale2-knzscale1
kamp randh knzbi,krrate
ktrig metro krrate ;generate a trigger to do random calculation
if ktrig=1 then
gkRandcurrent1=gkNz1 ;load array used for maska FFT into current array
copya2ftab gkRandcurrent1,201 ;write current array to f201
koffsetindex=0 ;generate new random table and load into target array
 until koffsetindex==gisize do
 gkRandtarget1[koffsetindex] = rand:k(kamp,2) ;seed of greater than 1 gets seed from clock
 koffsetindex += 1
 od
copya2ftab gkRandtarget1,202 ;write target array to f202 
event "i",17,0,1/krrate
endif
endin

instr 17 ;instrument to morph two arrays
kmorph line 0,p3,1 ;ramp from 0-1
gkNz1 arrmorph kmorph,gkRandcurrent1,gkRandtarget1,gisize ;actual morphing from current to target
copya2ftab gkNz1,200 ;write contents of active amp mask noise array into f200
endin

instr 20 ;randomly changing line segment arrays
klrate1 chnget "linerate1"
klrate2 chnget "linerate2"
if klrate1>klrate2 then ;invert values despite user input
 klratetemp=klrate2
 klrate2=klrate1
 klrate1=klratetemp
endif
klraterand randomh 0,klrate2-klrate1,klrate1,3
klrate=klrate1+klraterand
koffsetstart1 chnget "offsetstart1"
koffsetstart2 chnget "offsetstart2"
if koffsetstart1>koffsetstart2 then ;invert values despite user input
 koffsetstarttemp=koffsetstart2
 koffsetstart2=koffsetstart1
 koffsetstart1=koffsetstarttemp
endif
koffsetend1 chnget "offsetend1"
koffsetend2 chnget "offsetend2"
if koffsetend1>koffsetend2 then ;invert values despite user input
 koffsetendtemp=koffsetend2
 koffsetend2=koffsetend1
 koffsetend1=koffsetendtemp
endif
klineF1 chnget "lineF1"
klineF2 chnget "lineF2"
if klineF1>klineF2 then ;invert values despite user input
 klineFtemp=klineF2
 klineF2=klineF1
 klineF1=klineFtemp
endif
klinerate1 chnget "linerate1"
klinerate2 chnget "linerate2"
if klinerate1>klineF2 then ;invert values despite user input
 klineratetemp=klinerate2
 klinerate2=klinerate1
 klinerate1=klineratetemp
endif

koffsetstart randomi koffsetstart1,koffsetstart2,klrate,3
koffsetend randomi koffsetend1,koffsetend2,klrate,3
klineF randomi klineF1,klineF2,klrate,3
klineincr=((koffsetend-koffsetstart)/gisize)*klineF

ktrig metro gktrigger
if ktrig=1 then 
;if changed(klineincr)==1 then 
 koffsetindex=0
 ktemp=koffsetstart
 
  until koffsetindex==gisize do
  gkLine1[koffsetindex]=ktemp
 ktemp+=klineincr
 if klineincr>0 then
  if ktemp>koffsetend then
  ktemp=koffsetstart
  endif
 elseif klineincr<0 then
  if ktemp<koffsetend then
  ktemp=koffsetstart
  endif
 endif
 koffsetindex+=1
 od
 
endif
endin

instr 21 ;randomly changing line segment arrays
klrate1 chnget "linerate1"
klrate2 chnget "linerate2"
if klrate1>klrate2 then ;invert values despite user input
 klratetemp=klrate2
 klrate2=klrate1
 klrate1=klratetemp
endif
klraterand randomh 0,klrate2-klrate1,klrate1,3
klrate=klrate1+klraterand
koffsetstart1 chnget "offsetstart1"
koffsetstart2 chnget "offsetstart2"
if koffsetstart1>koffsetstart2 then ;invert values despite user input
 koffsetstarttemp=koffsetstart2
 koffsetstart2=koffsetstart1
 koffsetstart1=koffsetstarttemp
endif
koffsetend1 chnget "offsetend1"
koffsetend2 chnget "offsetend2"
if koffsetend1>koffsetend2 then ;invert values despite user input
 koffsetendtemp=koffsetend2
 koffsetend2=koffsetend1
 koffsetend1=koffsetendtemp
endif
klineF1 chnget "lineF1"
klineF2 chnget "lineF2"
if klineF1>klineF2 then ;invert values despite user input
 klineFtemp=klineF2
 klineF2=klineF1
 klineF1=klineFtemp
endif
klinerate1 chnget "linerate1"
klinerate2 chnget "linerate2"
if klinerate1>klineF2 then ;invert values despite user input
 klineratetemp=klinerate2
 klinerate2=klinerate1
 klinerate1=klineratetemp
endif

koffsetstart randomi koffsetstart1,koffsetstart2,klrate,3
koffsetend randomi koffsetend1,koffsetend2,klrate,3
klineF randomi klineF1,klineF2,klrate,3
klineincr=((koffsetend-koffsetstart)/gisize)*klineF

ktrig metro gktrigger
if ktrig=1 then 
;if changed(klineincr)==1 then 
 koffsetindex=0
 ktemp=koffsetstart
 
  until koffsetindex==gisize do
  gkLine2[koffsetindex]=ktemp
 ktemp+=klineincr
 if klineincr>0 then
  if ktemp>koffsetend then
  ktemp=koffsetstart
  endif
 elseif klineincr<0 then
  if ktemp<koffsetend then
  ktemp=koffsetstart
  endif
 endif
 koffsetindex+=1
 od

endif
endin

instr 22 ;randomly changing line segment arrays
klrate1 chnget "linerate1"
klrate2 chnget "linerate2"
if klrate1>klrate2 then ;invert values despite user input
 klratetemp=klrate2
 klrate2=klrate1
 klrate1=klratetemp
endif
klraterand randomh 0,klrate2-klrate1,klrate1,3
klrate=klrate1+klraterand
koffsetstart1 chnget "offsetstart1"
koffsetstart2 chnget "offsetstart2"
if koffsetstart1>koffsetstart2 then ;invert values despite user input
 koffsetstarttemp=koffsetstart2
 koffsetstart2=koffsetstart1
 koffsetstart1=koffsetstarttemp
endif
koffsetend1 chnget "offsetend1"
koffsetend2 chnget "offsetend2"
if koffsetend1>koffsetend2 then ;invert values despite user input
 koffsetendtemp=koffsetend2
 koffsetend2=koffsetend1
 koffsetend1=koffsetendtemp
endif
klineF1 chnget "lineF1"
klineF2 chnget "lineF2"
if klineF1>klineF2 then ;invert values despite user input
 klineFtemp=klineF2
 klineF2=klineF1
 klineF1=klineFtemp
endif
klinerate1 chnget "linerate1"
klinerate2 chnget "linerate2"
if klinerate1>klineF2 then ;invert values despite user input
 klineratetemp=klinerate2
 klinerate2=klinerate1
 klinerate1=klineratetemp
endif

koffsetstart randomi koffsetstart1,koffsetstart2,klrate,3
koffsetend randomi koffsetend1,koffsetend2,klrate,3
klineF randomi klineF1,klineF2,klrate,3
klineincr=((koffsetend-koffsetstart)/gisize)*klineF

ktrig metro gktrigger
if ktrig=1 then 
;if changed(klineincr)==1 then 
 koffsetindex=0
 ktemp=koffsetstart
 
  until koffsetindex==gisize do
  gkLine3[koffsetindex]=ktemp
 ktemp+=klineincr
 if klineincr>0 then
  if ktemp>koffsetend then
  ktemp=koffsetstart
  endif
 elseif klineincr<0 then
  if ktemp<koffsetend then
  ktemp=koffsetstart
  endif
 endif
 koffsetindex+=1
 od

endif
endin

instr 23 ;randomly changing line segment arrays
klrate1 chnget "linerate1"
klrate2 chnget "linerate2"
if klrate1>klrate2 then ;invert values despite user input
 klratetemp=klrate2
 klrate2=klrate1
 klrate1=klratetemp
endif
klraterand randomh 0,klrate2-klrate1,klrate1,3
klrate=klrate1+klraterand
koffsetstart1 chnget "offsetstart1"
koffsetstart2 chnget "offsetstart2"
if koffsetstart1>koffsetstart2 then ;invert values despite user input
 koffsetstarttemp=koffsetstart2
 koffsetstart2=koffsetstart1
 koffsetstart1=koffsetstarttemp
endif
koffsetend1 chnget "offsetend1"
koffsetend2 chnget "offsetend2"
if koffsetend1>koffsetend2 then ;invert values despite user input
 koffsetendtemp=koffsetend2
 koffsetend2=koffsetend1
 koffsetend1=koffsetendtemp
endif
klineF1 chnget "lineF1"
klineF2 chnget "lineF2"
if klineF1>klineF2 then ;invert values despite user input
 klineFtemp=klineF2
 klineF2=klineF1
 klineF1=klineFtemp
endif
klinerate1 chnget "linerate1"
klinerate2 chnget "linerate2"
if klinerate1>klineF2 then ;invert values despite user input
 klineratetemp=klinerate2
 klinerate2=klinerate1
 klinerate1=klineratetemp
endif

koffsetstart randomi koffsetstart1,koffsetstart2,klrate,3
koffsetend randomi koffsetend1,koffsetend2,klrate,3
klineF randomi klineF1,klineF2,klrate,3
klineincr=((koffsetend-koffsetstart)/gisize)*klineF

ktrig metro gktrigger
if ktrig=1 then
;if changed(klineincr)==1 then 
 koffsetindex=0
 ktemp=koffsetstart
 
  until koffsetindex==gisize do
  gkLine4[koffsetindex]=ktemp
 ktemp+=klineincr
 if klineincr>0 then
  if ktemp>koffsetend then
  ktemp=koffsetstart
  endif
 elseif klineincr<0 then
  if ktemp<koffsetend then
  ktemp=koffsetstart
  endif
 endif
 koffsetindex+=1
 od

endif
endin

instr 30 ;randomly changing harmonic filter
istep=6.283185307179586/gisize ;2pi/FFT size used to step through cosine calculations, one cycle per array size
ibincps=sr/gisize ;Hz per bin in the FFT
;grab the channel data
ksinamp1 chnget "sinamp1"
ksinamp2 chnget "sinamp2"
ksinF1 chnget "sinF1"
ksinF2 chnget "sinF2"
kspread1 chnget "spread1"
kspread2 chnget "spread2"
kctrh1 chnget "ctrh1"
kctrh2 chnget "ctrh2"
kQ1 chnget "Q1"
kQ2 chnget "Q2"
khspeed1 chnget "hspeed1"
khspeed2 chnget "hspeed2"
;sort the data to min/max despite user input
if ksinamp1>ksinamp2 then ;invert values despite user input
 ksinamptemp=ksinamp2
 ksinamp2=ksinamp1
 ksinamp1=ksinamptemp
endif
if ksinF1>ksinF2 then ;invert values despite user input
 ksinFtemp=ksinF2
 ksinF2=ksinF1
 ksinF1=ksinFtemp
endif
if kspread1>kspread2 then ;invert values despite user input
 kspreadtemp=kspread2
 kspread2=kspread1
 kspread1=kspreadtemp
endif
if kctrh1>kctrh2 then ;invert values despite user input
 kctrhtemp=kctrh2
 kctrh2=kctrh1
 kctrh1=kctrhtemp
endif
if kQ1>kQ2 then ;invert values despite user input
 kQtemp=kQ2
 kQ2=kQ1
 kQ1=kQtemp
endif
if khspeed1>khspeed2 then ;invert values despite user input
 khspeedtemp=khspeed2
 khspeed2=khspeed1
 khspeed1=khspeedtemp
endif
khraterand randomh 0,khspeed2-khspeed1,khspeed1,3
khrate=khspeed1+khraterand

ksinamp randomi ksinamp1,ksinamp2,khrate,3
ksinF randomi ksinF1,ksinF2,khrate,3
kspread randomi kspread1,kspread2,khrate,3
kctrh randomi kctrh1,kctrh2,khrate,3
kQ randomi kQ1,kQ2,khrate,3

ktrig metro gktrigger
if ktrig=1 then 
;if changed(ksinamp,ksinF,kspread,kctrh,kQ)==1 then 
 koffsetindex=0
 
  until koffsetindex==gisize do
   kbinF=gisize/(ksinF/ibincps) ;desired fundamental cps/Hz per bin reaps cosine input multiplier
   gkFWinA[koffsetindex] = cos(limit:k(((koffsetindex-((ksinF*kctrh)/ibincps))*(istep/kspread)*kbinF),-3.14159265,3.14159265))*.5+.5
   gkCosA1[koffsetindex] = (cos(koffsetindex*kbinF*istep)*.5+.5)^kQ*ksinamp
   koffsetindex += 1
  od

gkCosA=gkCosA1*gkFWinA

endif
endin

instr 31 ;randomly changing harmonic filter
istep=6.283185307179586/gisize ;2pi/FFT size used to step through cosine calculations, one cycle per array size
ibincps=sr/gisize ;Hz per bin in the FFT
;grab the channel data
ksinamp1 chnget "sinamp1"
ksinamp2 chnget "sinamp2"
ksinF1 chnget "sinF1"
ksinF2 chnget "sinF2"
kspread1 chnget "spread1"
kspread2 chnget "spread2"
kctrh1 chnget "ctrh1"
kctrh2 chnget "ctrh2"
kQ1 chnget "Q1"
kQ2 chnget "Q2"
khspeed1 chnget "hspeed1"
khspeed2 chnget "hspeed2"
;sort the data to min/max despite user input
if ksinamp1>ksinamp2 then ;invert values despite user input
 ksinamptemp=ksinamp2
 ksinamp2=ksinamp1
 ksinamp1=ksinamptemp
endif
if ksinF1>ksinF2 then ;invert values despite user input
 ksinFtemp=ksinF2
 ksinF2=ksinF1
 ksinF1=ksinFtemp
endif
if kspread1>kspread2 then ;invert values despite user input
 kspreadtemp=kspread2
 kspread2=kspread1
 kspread1=kspreadtemp
endif
if kctrh1>kctrh2 then ;invert values despite user input
 kctrhtemp=kctrh2
 kctrh2=kctrh1
 kctrh1=kctrhtemp
endif
if kQ1>kQ2 then ;invert values despite user input
 kQtemp=kQ2
 kQ2=kQ1
 kQ1=kQtemp
endif
if khspeed1>khspeed2 then ;invert values despite user input
 khspeedtemp=khspeed2
 khspeed2=khspeed1
 khspeed1=khspeedtemp
endif
khraterand randomh 0,khspeed2-khspeed1,khspeed1,3
khrate=khspeed1+khraterand

ksinamp randomi ksinamp1,ksinamp2,khrate,3
ksinF randomi ksinF1,ksinF2,khrate,3
kspread randomi kspread1,kspread2,khrate,3
kctrh randomi kctrh1,kctrh2,khrate,3
kQ randomi kQ1,kQ2,khrate,3

ktrig metro gktrigger
if ktrig=1 then 
;if changed(ksinamp,ksinF,kspread,kctrh,kQ)==1 then 
 koffsetindex=0
 
  until koffsetindex==gisize do
   kbinF=gisize/(ksinF/ibincps) ;desired fundamental cps/Hz per bin reaps cosine input multiplier
   gkFWinB[koffsetindex] = cos(limit:k(((koffsetindex-((ksinF*kctrh)/ibincps))*(istep/kspread)*kbinF),-3.14159265,3.14159265))*.5+.5
   gkCosB1[koffsetindex] = (cos(koffsetindex*kbinF*istep)*.5+.5)^kQ*ksinamp
   koffsetindex += 1
  od

gkCosB=gkCosB1*gkFWinB

endif
endin

instr 32 ;randomly changing harmonic filter
istep=6.283185307179586/gisize ;2pi/FFT size used to step through cosine calculations, one cycle per array size
ibincps=sr/gisize ;Hz per bin in the FFT
;grab the channel data
ksinamp1 chnget "sinamp1"
ksinamp2 chnget "sinamp2"
ksinF1 chnget "sinF1"
ksinF2 chnget "sinF2"
kspread1 chnget "spread1"
kspread2 chnget "spread2"
kctrh1 chnget "ctrh1"
kctrh2 chnget "ctrh2"
kQ1 chnget "Q1"
kQ2 chnget "Q2"
khspeed1 chnget "hspeed1"
khspeed2 chnget "hspeed2"
;sort the data to min/max despite user input
if ksinamp1>ksinamp2 then ;invert values despite user input
 ksinamptemp=ksinamp2
 ksinamp2=ksinamp1
 ksinamp1=ksinamptemp
endif
if ksinF1>ksinF2 then ;invert values despite user input
 ksinFtemp=ksinF2
 ksinF2=ksinF1
 ksinF1=ksinFtemp
endif
if kspread1>kspread2 then ;invert values despite user input
 kspreadtemp=kspread2
 kspread2=kspread1
 kspread1=kspreadtemp
endif
if kctrh1>kctrh2 then ;invert values despite user input
 kctrhtemp=kctrh2
 kctrh2=kctrh1
 kctrh1=kctrhtemp
endif
if kQ1>kQ2 then ;invert values despite user input
 kQtemp=kQ2
 kQ2=kQ1
 kQ1=kQtemp
endif
if khspeed1>khspeed2 then ;invert values despite user input
 khspeedtemp=khspeed2
 khspeed2=khspeed1
 khspeed1=khspeedtemp
endif
khraterand randomh 0,khspeed2-khspeed1,khspeed1,3
khrate=khspeed1+khraterand

ksinamp randomi ksinamp1,ksinamp2,khrate,3
ksinF randomi ksinF1,ksinF2,khrate,3
kspread randomi kspread1,kspread2,khrate,3
kctrh randomi kctrh1,kctrh2,khrate,3
kQ randomi kQ1,kQ2,khrate,3

ktrig metro gktrigger
if ktrig=1 then
;if changed(ksinamp,ksinF,kspread,kctrh,kQ)==1 then 
 koffsetindex=0
 
  until koffsetindex==gisize do
   kbinF=gisize/(ksinF/ibincps) ;desired fundamental cps/Hz per bin reaps cosine input multiplier
   gkFWinC[koffsetindex] = cos(limit:k(((koffsetindex-((ksinF*kctrh)/ibincps))*(istep/kspread)*kbinF),-3.14159265,3.14159265))*.5+.5
   gkCosC1[koffsetindex] = (cos(koffsetindex*kbinF*istep)*.5+.5)^kQ*ksinamp
   koffsetindex += 1
  od

gkCosC=gkCosC1*gkFWinC

endif
endin

instr 33 ;randomly changing harmonic filter
istep=6.283185307179586/gisize ;2pi/FFT size used to step through cosine calculations, one cycle per array size
ibincps=sr/gisize ;Hz per bin in the FFT
;grab the channel data
ksinamp1 chnget "sinamp1"
ksinamp2 chnget "sinamp2"
ksinF1 chnget "sinF1"
ksinF2 chnget "sinF2"
kspread1 chnget "spread1"
kspread2 chnget "spread2"
kctrh1 chnget "ctrh1"
kctrh2 chnget "ctrh2"
kQ1 chnget "Q1"
kQ2 chnget "Q2"
khspeed1 chnget "hspeed1"
khspeed2 chnget "hspeed2"
;sort the data to min/max despite user input
if ksinamp1>ksinamp2 then ;invert values despite user input
 ksinamptemp=ksinamp2
 ksinamp2=ksinamp1
 ksinamp1=ksinamptemp
endif
if ksinF1>ksinF2 then ;invert values despite user input
 ksinFtemp=ksinF2
 ksinF2=ksinF1
 ksinF1=ksinFtemp
endif
if kspread1>kspread2 then ;invert values despite user input
 kspreadtemp=kspread2
 kspread2=kspread1
 kspread1=kspreadtemp
endif
if kctrh1>kctrh2 then ;invert values despite user input
 kctrhtemp=kctrh2
 kctrh2=kctrh1
 kctrh1=kctrhtemp
endif
if kQ1>kQ2 then ;invert values despite user input
 kQtemp=kQ2
 kQ2=kQ1
 kQ1=kQtemp
endif
if khspeed1>khspeed2 then ;invert values despite user input
 khspeedtemp=khspeed2
 khspeed2=khspeed1
 khspeed1=khspeedtemp
endif
khraterand randomh 0,khspeed2-khspeed1,khspeed1,3
khrate=khspeed1+khraterand

ksinamp randomi ksinamp1,ksinamp2,khrate,3
ksinF randomi ksinF1,ksinF2,khrate,3
kspread randomi kspread1,kspread2,khrate,3
kctrh randomi kctrh1,kctrh2,khrate,3
kQ randomi kQ1,kQ2,khrate,3

ktrig metro gktrigger
if ktrig=1 then
;if changed(ksinamp,ksinF,kspread,kctrh,kQ)==1 then 
 koffsetindex=0
 
  until koffsetindex==gisize do
   kbinF=gisize/(ksinF/ibincps) ;desired fundamental cps/Hz per bin reaps cosine input multiplier
   gkFWinD[koffsetindex] = cos(limit:k(((koffsetindex-((ksinF*kctrh)/ibincps))*(istep/kspread)*kbinF),-3.14159265,3.14159265))*.5+.5
   gkCosD1[koffsetindex] = (cos(koffsetindex*kbinF*istep)*.5+.5)^kQ*ksinamp
   koffsetindex += 1
  od

gkCosD=gkCosD1*gkFWinD

endif
endin

instr 101   ;filter array summing and display

gkSumL1=gkLine1+gkNz1+gkCosA 
 gkSumL1 limit gkSumL1,.0001,1
 gkSumL1i=1-gkSumL1
gkSumR1=gkLine2+gkNz2+gkCosB 
 gkSumR1 limit gkSumR1,.0001,1
 gkSumR1i=1-gkSumR1
gkSumL2=gkLine3+gkNz3+gkCosC
 gkSumL2 limit gkSumL2,.0001,1
 gkSumL2i=1-gkSumL2
gkSumR2=gkLine4+gkNz4+gkCosD 
 gkSumR2 limit gkSumR2,.0001,1
 gkSumR2i=1-gkSumR2
 
 copya2ftab gkSumL1,99 ;copies first summed array into f99 for display and for use with pvsmask (which uses ftables)
 copya2ftab gkSumL1i,100
 copya2ftab gkSumR1,101
 copya2ftab gkSumR1i,102
 copya2ftab gkSumL2,103
 copya2ftab gkSumL2i,104
 copya2ftab gkSumR2,105
 copya2ftab gkSumR2i,106
 event "i",111,0,.01
endin

instr 111 ;main filter display--displays L1 filter
cabbageSet "arraydisplayL","tableNumber",99
endin

instr 200 ;actual filter instrument
;irecch chnget "recch" ;1=1to2 2=1to4 3=1to8 4=2to4 5=2to8 6=2to16
kfmix chnget "fmix"
kfmix=sqrt(kfmix)
ksource chnget "filtsource" ;1=mic/line, 2=sf
if ksource=1 then
aL=gamicL
aR=gamicR
elseif ksource=2 then
aL=gasfL
aR=gasfR
endif

fftL pvsanal aL,gisize,gisize*.25,gisize,1
fftR pvsanal aR,gisize,gisize*.25,gisize,1
kframe pvs2array gkBinsL,fftL ;constantly writing fftL into an array gkBins so I can grab it
kframeB pvs2array gkBinsR,fftR
fpanL1 pvsmaska fftL,99,1 ;f99 is gkSumL1
fpanL1i pvsmaska fftL,100,1 ;f100 is gkSumL1i (inverse of gkSumL1)
afftL1 pvsynth fpanL1
afftL1i pvsynth fpanL1i
  fpanR1 pvsmaska fftL,101,1 ;f99 is gkSumR1
  fpanR1i pvsmaska fftL,102,1 ;f100 is gkSumR1i (inverse of gkSumL1)
  afftR1 pvsynth fpanR1
  afftR1i pvsynth fpanR1i
fpanL2 pvsmaska fftL,103,1 ;f99 is gkSumL2
fpanL2i pvsmaska fftL,104,1 ;f100 is gkSumL2i (inverse of gkSumL1)
afftL2 pvsynth fpanL2
afftL2i pvsynth fpanL2i
  fpanR2 pvsmaska fftL,105,1 ;f99 is gkSumR2
  fpanR2i pvsmaska fftL,106,1 ;f100 is gkSumR2i (inverse of gkSumL1)
  afftR2 pvsynth fpanR2
  afftR2i pvsynth fpanR2i
;;maybe I don't need these since the sum of each pair of filters should never be more than the original signal???
gafiltL1=balance((aL*(1-kfmix))+(afftL1*kfmix),aL) ;add "depth" control by mixing with input signal
gafiltL1i=balance((aL*(1-kfmix))+(afftL1i*kfmix),aL)
gafiltR1=balance((aR*(1-kfmix))+(afftR1*kfmix),aR) ;add "depth" control by mixing with input signal
gafiltR1i=balance((aR*(1-kfmix))+(afftR1i*kfmix),aR)
gafiltL2=balance((aL*(1-kfmix))+(afftL2*kfmix),aL) ;add "depth" control by mixing with input signal
gafiltL2i=balance((aL*(1-kfmix))+(afftL2i*kfmix),aL)
gafiltR2=balance((aR*(1-kfmix))+(afftR2*kfmix),aR) ;add "depth" control by mixing with input signal
gafiltR2i=balance((aR*(1-kfmix))+(afftR2i*kfmix),aR)
kfout chnget "fout"
outs gafiltL1*kfout,gafiltL1i*kfout
endin

instr 600	; record file
irecch chnget "recch" ;1=1to2 2=1to4 3=1to8 4=2to4 5=2to8
afinalL=gafiltL
afinalR=gafiltR

ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname  sprintf "SFilter_%s", Sfilnam
 gSnameL  sprintf "SFilterL_%s", Sfilnam
 gSnameR  sprintf "SFilterR_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then ;1=1to2 2=1to4 3=2to4 4=2to8
   fout gSname,imode,gafiltL1,gafiltL1i
  elseif irecch=2 then
   fout gSname,imode,gafiltL1,gafiltL1i,gafiltL2,gafiltL2i
  elseif irecch=3 then
   fout gSname,imode,gafiltL1,gafiltL1i,gafiltR1,gafiltR1i
  elseif irecch=4 then
   fout gSnameL,imode,gafiltL1,gafiltL1i,gafiltR1,gafiltR1i,gafiltL2,gafiltL2i,gafiltR2,gafiltR2i
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play" ;figure out how to set the value of "play" to 0
endin

instr 700
clear gamicL,gamicR,gasfL,gasfR,gafiltL1,gafiltL1i,gafiltR1,gafiltR1i,gafiltL2,gafiltL2i,gafiltR2,gafiltR2i
endin

</CsInstruments>

<CsScore>
f0 z ;causes Csound to run infinitely
f1 0 2048 7 .5 2048 .5 ;creates a base function to load into kSum[]
f25 0 32768 19 1 .5 270 .5 ;provides a sinusoid window function for i41

f50 0 2048 10 0 ;creates default table for displaying line arrays

f99 0 2048 10 0 ;this is a null table created to display arrays--arrays are loaded into it, L1
f100 0 2048 10 0 ;L1i channel amps--inverse of f99
f101 0 2048 10 0 ;R1
f102 0 2048 10 0 ;R1i
f103 0 2048 10 0 ;L2
f104 0 2048 10 0 ;L2i
f105 0 2048 10 0 ;R2
f106 0 2048 10 0 ;R2i

f200 0 2048 10 0 ;blank table for use for random 1
f201 0 2048 10 0 ;current random table
f202 0 2048 10 0 ;target random table

f203 0 2048 10 0 ;random 2
f204 0 2048 10 0 
f205 0 2048 10 0 

f206 0 2048 10 0 ;random 3
f207 0 2048 10 0 
f208 0 2048 10 0 

f209 0 2048 10 0 ;random 4
f210 0 2048 10 0 
f211 0 2048 10 0 


f300 0 2048 10 0 ;target table for drunk random walk
f301 0 2048 10 0 ;current random table
f302 0 2048 10 0 ;target random table

f400 0 2048 10 0 ;target table for harmonic filter
f401 0 2048 10 0 ;target table for cos filter display

f500 0 2048 10 0 ;target table for writing spectral data

i1 0 999999     ;mic, sf, effect on/off management
;i10,12,14,16 ;generates random table, triggers i6
;i11,13,15,17 ;morphs from current random to target random at portamento time
i101 0 999999    ;live array summing and writing to ftables for pvsmaska 
i200 0 999999    ;FFT filter instrument
i700 0 999999   ;global audio clear

</CsScore>
</CsoundSynthesizer>
